<?xml version="1.0" encoding="ascii"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
          "DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>pyxmpp.jabber.dataforms.Form</title>
  <link rel="stylesheet" href="epydoc.css" type="text/css" />
  <script type="text/javascript" src="epydoc.js"></script>
</head>

<body bgcolor="white" text="black" link="blue" vlink="#204080"
      alink="#204080">
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table width="100%" cellpadding="0" cellspacing="0">
  <tr valign="top">
    <td width="100%">
      <span class="breadcrumbs">
        <a href="pyxmpp-module.html">Package&nbsp;pyxmpp</a> ::
        <a href="pyxmpp.jabber-module.html">Package&nbsp;jabber</a> ::
        <a href="pyxmpp.jabber.dataforms-module.html">Module&nbsp;dataforms</a> ::
        Class&nbsp;Form
      </span>
    </td>
    <td>
      <table cellpadding="0" cellspacing="0">
        <!-- hide/show private -->
        <tr><td align="right"><span class="options">[<a href="javascript:void(0);" class="privatelink"
    onclick="toggle_private();">hide&nbsp;private</a>]</span></td></tr>
      </table>
    </td>
  </tr>
</table>
<!-- ==================== CLASS DESCRIPTION ==================== -->
<h1 class="epydoc">Class Form</h1><p class="nomargin-top"><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form">source&nbsp;code</a></span></p>
<pre class="base-tree">
                 object --+    
                          |    
<a href="pyxmpp.objects.StanzaPayloadObject-class.html">objects.StanzaPayloadObject</a> --+
                              |
                             <strong class="uidshort">Form</strong>
</pre>

<hr />
<p>A JEP-0004 compliant data form.</p>
<p>Additionally to the direct access to the contained fields via the <a href="pyxmpp.jabber.dataforms.Form-class.html#fields" class="link">fields</a> attribute,
<a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a> object provides an iterator and mapping interface for field access. E.g.:</p>
<pre class="rst-literal-block">
for field in form:
    ...
</pre>
<p>or:</p>
<pre class="rst-literal-block">
field = form['field_name']
</pre>

<!-- ==================== INSTANCE METHODS ==================== -->
<a name="section-InstanceMethods"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Methods</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceMethods"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#__init__" class="summary-sig-name">__init__</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode_or_type</span>=<span class="summary-sig-default"><code class="variable-quote">'</code><code class="variable-string">form</code><code class="variable-quote">'</code></span>,
        <span class="summary-sig-arg">title</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">instructions</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">fields</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">reported_fields</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">items</span>=<span class="summary-sig-default">None</span>)</span><br />
      Initialize a <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a> object.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__init__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__getitem__"></a><span class="summary-sig-name">__getitem__</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">name_or_index</span>)</span></td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__getitem__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__contains__"></a><span class="summary-sig-name">__contains__</span>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">name</span>)</span></td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__contains__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a name="__iter__"></a><span class="summary-sig-name">__iter__</span>(<span class="summary-sig-arg">self</span>)</span></td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__iter__">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#add_field" class="summary-sig-name">add_field</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">name</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">values</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">field_type</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">label</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">options</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">required</span>=<span class="summary-sig-default">False</span>,
        <span class="summary-sig-arg">desc</span>=<span class="summary-sig-default">None</span>,
        <span class="summary-sig-arg">value</span>=<span class="summary-sig-default">None</span>)</span><br />
      Add a field to the form.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.add_field">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.jabber.dataforms.Item-class.html" class="link">Item</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#add_item" class="summary-sig-name">add_item</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">fields</span>=<span class="summary-sig-default">None</span>)</span><br />
      Add and item to the form.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.add_item">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#make_submit" class="summary-sig-name">make_submit</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">keep_types</span>=<span class="summary-sig-default">False</span>)</span><br />
      Make a &quot;submit&quot; form using data in <code class="link">self</code>.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.make_submit">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type"><a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a></span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#copy" class="summary-sig-name">copy</a>(<span class="summary-sig-arg">self</span>)</span><br />
      Get a deep copy of <code class="link">self</code>.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.copy">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#complete_xml_element" class="summary-sig-name">complete_xml_element</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>,
        <span class="summary-sig-arg">doc</span>)</span><br />
      Complete the XML node with <code class="link">self</code> content.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.complete_xml_element">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#__from_xml" class="summary-sig-name" onclick="show_private();">__from_xml</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>)</span><br />
      Initialize a <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a> object from an XML element.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__from_xml">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
<tr class="private">
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
      <table width="100%" cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td><span class="summary-sig"><a href="pyxmpp.jabber.dataforms.Form-class.html#__get_reported" class="summary-sig-name" onclick="show_private();">__get_reported</a>(<span class="summary-sig-arg">self</span>,
        <span class="summary-sig-arg">xmlnode</span>)</span><br />
      Parse the &lt;reported/&gt; element of the form.</td>
          <td align="right" valign="top">
            <span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__get_reported">source&nbsp;code</a></span>
            
          </td>
        </tr>
      </table>
      
    </td>
  </tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code><a href="pyxmpp.objects.StanzaPayloadObject-class.html">objects.StanzaPayloadObject</a></code></b>:
      <code><a href="pyxmpp.objects.StanzaPayloadObject-class.html#as_xml">as_xml</a></code>
      </p>
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__delattr__</code>,
      <code>__format__</code>,
      <code>__getattribute__</code>,
      <code>__hash__</code>,
      <code>__new__</code>,
      <code>__reduce__</code>,
      <code>__reduce_ex__</code>,
      <code>__repr__</code>,
      <code>__setattr__</code>,
      <code>__sizeof__</code>,
      <code>__str__</code>,
      <code>__subclasshook__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== CLASS VARIABLES ==================== -->
<a name="section-ClassVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Class Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-ClassVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="allowed_types"></a><span class="summary-name">allowed_types</span> = <code title="('form', 'submit', 'cancel', 'result')"><code class="variable-group">(</code><code class="variable-quote">'</code><code class="variable-string">form</code><code class="variable-quote">'</code><code class="variable-op">, </code><code class="variable-quote">'</code><code class="variable-string">submit</code><code class="variable-quote">'</code><code class="variable-op">, </code><code class="variable-quote">'</code><code class="variable-string">cancel</code><code class="variable-quote">'</code><code class="variable-op">, </code><code class="variable-quote">'</code><code class="variable-string">result</code><code class="variable-quote">'</code><code class="variable-group">)</code></code>
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">unicode</code></span>
    </td><td class="summary">
        <a name="xml_element_name"></a><span class="summary-name">xml_element_name</span> = <code title="'x'"><code class="variable-quote">'</code><code class="variable-string">x</code><code class="variable-quote">'</code></code><br />
      : name for the XML element provided by the class.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">unicode</code></span>
    </td><td class="summary">
        <a name="xml_element_namespace"></a><span class="summary-name">xml_element_namespace</span> = <code title="'jabber:x:data'"><code class="variable-quote">'</code><code class="variable-string">jabber:x:data</code><code class="variable-quote">'</code></code><br />
      : namespace URI for the XML element provided
by the class.
    </td>
  </tr>
</table>
<!-- ==================== INSTANCE VARIABLES ==================== -->
<a name="section-InstanceVariables"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Instance Variables</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-InstanceVariables"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a></span>
    </td><td class="summary">
        <a name="fields"></a><span class="summary-name">fields</span><br />
      : the fields in the form.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">unicode</code></span>
    </td><td class="summary">
        <a name="instructions"></a><span class="summary-name">instructions</span><br />
      : instructions for a form user.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Item-class.html" class="link">Item</a></span>
    </td><td class="summary">
        <a name="items"></a><span class="summary-name">items</span><br />
      : items in a multi-item data form.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a></span>
    </td><td class="summary">
        <a name="reported_fields"></a><span class="summary-name">reported_fields</span><br />
      : list of fields returned in a multi-item data form.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">: <code class="link">unicode</code></span>
    </td><td class="summary">
        <a name="title"></a><span class="summary-name">title</span><br />
      : form title.
    </td>
  </tr>
<tr>
    <td width="15%" align="right" valign="top" class="summary">
      <span class="summary-type">&nbsp;</span>
    </td><td class="summary">
        <a name="type"></a><span class="summary-name">type</span><br />
      : form type (&quot;form&quot;, &quot;submit&quot;, &quot;cancel&quot; or &quot;result&quot;).
    </td>
  </tr>
</table>
<!-- ==================== PROPERTIES ==================== -->
<a name="section-Properties"></a>
<table class="summary" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Properties</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-Properties"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
  <tr>
    <td colspan="2" class="summary">
    <p class="indent-wrapped-lines"><b>Inherited from <code>object</code></b>:
      <code>__class__</code>
      </p>
    </td>
  </tr>
</table>
<!-- ==================== METHOD DETAILS ==================== -->
<a name="section-MethodDetails"></a>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr bgcolor="#70b0f0" class="table-header">
  <td colspan="2" class="table-header">
    <table border="0" cellpadding="0" cellspacing="0" width="100%">
      <tr valign="top">
        <td align="left"><span class="table-header">Method Details</span></td>
        <td align="right" valign="top"
         ><span class="options">[<a href="#section-MethodDetails"
         class="privatelink" onclick="toggle_private();"
         >hide private</a>]</span></td>
      </tr>
    </table>
  </td>
</tr>
</table>
<a name="__init__"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__init__</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode_or_type</span>=<span class="sig-default"><code class="variable-quote">'</code><code class="variable-string">form</code><code class="variable-quote">'</code></span>,
        <span class="sig-arg">title</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">instructions</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">fields</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">reported_fields</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">items</span>=<span class="sig-default">None</span>)</span>
    <br /><em class="fname">(Constructor)</em>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__init__">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize a <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a> object.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode_or_type</code></strong> (: <code class="link">libxml2.xmlNode</code> or <code class="link">str</code>) - : XML element to parse or a form title.</li>
        <li><strong class="pname"><code>title</code></strong> (: <code class="link">unicode</code>) - : form title.</li>
        <li><strong class="pname"><code>instructions</code></strong> (: <code class="link">unicode</code>) - : instructions for the form.</li>
        <li><strong class="pname"><code>fields</code></strong> (: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a>) - : form fields.</li>
        <li><strong class="pname"><code>reported_fields</code></strong> (: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a>) - : fields reported in multi-item data.</li>
        <li><strong class="pname"><code>items</code></strong> (: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Item-class.html" class="link">Item</a>) - : items of multi-item data.</li>
    </ul></dd>
    <dt>Overrides:
        object.__init__
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="add_field"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">add_field</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">name</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">values</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">field_type</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">label</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">options</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">required</span>=<span class="sig-default">False</span>,
        <span class="sig-arg">desc</span>=<span class="sig-default">None</span>,
        <span class="sig-arg">value</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.add_field">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Add a field to the form.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>name</code></strong> (: <code class="link">unicode</code>) - : field name.</li>
        <li><strong class="pname"><code>values</code></strong> (: <code class="link">list</code> of <code class="link">unicode</code>) - : raw field values. Not to be used together with <code class="link">value</code>.</li>
        <li><strong class="pname"><code>field_type</code></strong> (: <code class="link">str</code>) - : field type.</li>
        <li><strong class="pname"><code>label</code></strong> (: <code class="link">unicode</code>) - : field label.</li>
        <li><strong class="pname"><code>options</code></strong> (: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Option-class.html" class="link">Option</a>) - : optional values for the field.</li>
        <li><strong class="pname"><code>required</code></strong> (: <code class="link">bool</code>) - : <code class="link">True</code> if the field is required.</li>
        <li><strong class="pname"><code>desc</code></strong> (: <code class="link">unicode</code>) - : natural-language description of the field.</li>
        <li><strong class="pname"><code>value</code></strong> (: <code class="link">bool</code> for &quot;boolean&quot; field, <a href="pyxmpp.jid.JID-class.html" class="link">JID</a> for &quot;jid-single&quot;, <code class="link">list</code> of <a href="pyxmpp.jid.JID-class.html" class="link">JID</a>
for &quot;jid-multi&quot;, <code class="link">list</code> of <code class="link">unicode</code> for &quot;list-multi&quot; and &quot;text-multi&quot;
and <code class="link">unicode</code> for other field types.) - : field value or values in a field_type-specific type. May be used only
if <code class="link">values</code> parameter is not provided.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a></dt>
        <dd>the field added.</dd>
  </dl>
</td></tr></table>
</div>
<a name="add_item"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">add_item</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">fields</span>=<span class="sig-default">None</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.add_item">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Add and item to the form.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>fields</code></strong> (: <code class="link">list</code> of <a href="pyxmpp.jabber.dataforms.Field-class.html" class="link">Field</a>) - : fields of the item (they may be added later).</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.jabber.dataforms.Item-class.html" class="link">Item</a></dt>
        <dd>the item added.</dd>
  </dl>
</td></tr></table>
</div>
<a name="make_submit"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">make_submit</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">keep_types</span>=<span class="sig-default">False</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.make_submit">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  <p>Make a &quot;submit&quot; form using data in <code class="link">self</code>.</p>
<p>Remove uneeded information from the form. The information removed
includes: title, instructions, field labels, fixed fields etc.</p>
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>keep_types</code></strong> (: <code class="link">bool</code>) - : when <code class="link">True</code> field type information will be included
in the result form. That is usually not needed.</li>
    </ul></dd>
    <dt>Returns: <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a></dt>
        <dd>the form created.</dd>
    <dt>Raises:</dt>
    <dd><ul class="nomargin-top">
        <li><code><strong class='fraise'>ValueError</strong></code> - when any required field has no value.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="copy"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">copy</span>(<span class="sig-arg">self</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.copy">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Get a deep copy of <code class="link">self</code>.
  <dl class="fields">
    <dt>Returns: <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a></dt>
        <dd>a deep copy of <code class="link">self</code>.</dd>
  </dl>
</td></tr></table>
</div>
<a name="complete_xml_element"></a>
<div>
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">complete_xml_element</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>,
        <span class="sig-arg">doc</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.complete_xml_element">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Complete the XML node with <code class="link">self</code> content.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : XML node with the element being built. It has already
right name and namespace, but no attributes or content.</li>
        <li><strong class="pname"><code>doc</code></strong> (: <code class="link">libxml2.xmlDoc</code>) - : document to which the element belongs.</li>
    </ul></dd>
    <dt>Overrides:
        <a href="pyxmpp.objects.StanzaPayloadObject-class.html#complete_xml_element">objects.StanzaPayloadObject.complete_xml_element</a>
    </dt>
  </dl>
</td></tr></table>
</div>
<a name="__from_xml"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__from_xml</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__from_xml">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Initialize a <a href="pyxmpp.jabber.dataforms.Form-class.html" class="link">Form</a> object from an XML element.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the XML element.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<a name="__get_reported"></a>
<div class="private">
<table class="details" border="1" cellpadding="3"
       cellspacing="0" width="100%" bgcolor="white">
<tr><td>
  <table width="100%" cellpadding="0" cellspacing="0" border="0">
  <tr valign="top"><td>
  <h3 class="epydoc"><span class="sig"><span class="sig-name">__get_reported</span>(<span class="sig-arg">self</span>,
        <span class="sig-arg">xmlnode</span>)</span>
  </h3>
  </td><td align="right" valign="top"
    ><span class="codelink"><a href="pyxmpp.jabber.dataforms-pysrc.html#Form.__get_reported">source&nbsp;code</a></span>&nbsp;
    </td>
  </tr></table>
  
  Parse the &lt;reported/&gt; element of the form.
  <dl class="fields">
    <dt>Parameters:</dt>
    <dd><ul class="nomargin-top">
        <li><strong class="pname"><code>xmlnode</code></strong> (: <code class="link">libxml2.xmlNode</code>) - : the element to parse.</li>
    </ul></dd>
  </dl>
</td></tr></table>
</div>
<br />
<!-- ==================== NAVIGATION BAR ==================== -->
<table class="navbar" border="0" width="100%" cellpadding="0"
       bgcolor="#a0c0ff" cellspacing="0">
  <tr valign="middle">
  <!-- Home link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="pyxmpp-module.html">Home</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Tree link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="module-tree.html">Trees</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Index link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="identifier-index.html">Indices</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Help link -->
      <th>&nbsp;&nbsp;&nbsp;<a
        href="help.html">Help</a>&nbsp;&nbsp;&nbsp;</th>

  <!-- Project homepage -->
      <th class="navbar" align="right" width="100%">
        <table border="0" cellpadding="0" cellspacing="0">
          <tr><th class="navbar" align="center"
            ><a class="navbar" target="_top" href="http://pyxmpp.jajcus.net/">PyXMPP</a></th>
          </tr></table></th>
  </tr>
</table>
<table border="0" cellpadding="0" cellspacing="0" width="100%%">
  <tr>
    <td align="left" class="footer">
    Generated by Epydoc 3.0.1 on Sun May  8 13:35:00 2011
    </td>
    <td align="right" class="footer">
      <a target="mainFrame" href="http://epydoc.sourceforge.net"
        >http://epydoc.sourceforge.net</a>
    </td>
  </tr>
</table>

<script type="text/javascript">
  <!--
  // Private objects are initially displayed (because if
  // javascript is turned off then we want them to be
  // visible); but by default, we want to hide them.  So hide
  // them unless we have a cookie that says to show them.
  checkCookie();
  // -->
</script>
</body>
</html>
